{
                 Independent HelpSoft Laboratory present
            ͻ
                 ˿˿˿ͻ ˿˿ͻ   
                 δ˿              
                                   
                                                              
                 NetWare 3.11 API Library for Turbo Pascal    
                                  by                          
                        S.Perevoznik and V.Kononov            
                                 1994                         
            ͼ
}

Unit NetCon;

{ ࠢ ᮥ  䠩- ࢥ஬}

Interface

Function GetConnectionNumber      : byte;
{  ᢮  ᮥ  ।⠥ 䠩-ࢥ஬}

Function SetPreferredConnectionID(ConnectionID : byte) : byte;
{ ⠭ 䨪 ᮥ ।⠥ 䠩-ࢥ }

Function GetPreferredConnectionID : byte;
{  䨪 ᮥ ।⠥ 䠩-ࢥ}

Function GetDefaultConnectionID   : byte;
{  䨪 䠩-ࢥ, ਭ  㬮砭}

Function SetPrimaryConnectionID(ConnectionID : byte)   : byte;
{ ⠭ 䨪 ᮥ ࢨ筮 䠩-ࢥ}

Function GetPrimaryConnectionID   : byte;
{  䨪 ᮥ ࢨ筮 䠩-ࢥ}

Function AttachToFileServer(ConnectionID : byte) : byte;
{ ᮥ  䠩-ࢥ}

Function DetachFromFileServer(ConnectionID : byte)     : byte;
{ ᮥ  䠩-ࢥ}

Function LogoutFromFileServer(ConnectionID : byte)     : byte;
{ ॣ஢  䠩-ࢥ}

{   ᫥ ம楤  ।  :饭 S:O}

Procedure GetDriveDirectoryHandle(Var S, O : word);
{   ⠡ ⥫ ᪮}

Procedure GetDriveFlag(Var S, O : word);
{   ⠡ 䫠 ᪮}

Procedure GetDriveServerTableAddr(Var S, O : word);
{   ⠡ 䨪஢ ᮥ }

Procedure GetConnectionTableAddr(Var S,O : word);
{   ⠡ 䨪樮 ஢ ᮥ }

Procedure GetServerNameTableAddr(Var S, O : word);
{   ⠡  ஢ }

Implementation

uses Dos;

Function SetPreferredConnectionID(ConnectionID : byte) : byte;
Var
  R : registers;
begin
  r.AH := $F0;
  r.AL := $00;
  r.DL := ConnectionID;
  intr($21,r);
  SetPreferredConnectionID := r.AL;
end;


Function GetPreferredConnectionID : byte;
Var
  R : registers;
begin
  r.AH := $F0;
  r.AL := $01;
  intr($21,r);
  GetPreferredConnectionID := r.AL;
end;

Function GetDefaultConnectionID   : byte;
Var
  R : registers;
begin
  r.AH := $F0;
  r.AL := $02;
  intr($21,r);
  GetDefaultConnectionID := r.AL;
end;

Function SetPrimaryConnectionID(ConnectionID : byte)   : byte;
Var
  R : registers;
begin
  r.AH := $F0;
  r.AL := $04;
  r.DL := ConnectionID;
  intr($21,r);
  SetPrimaryConnectionID := r.AL;
end;

Function GetPrimaryConnectionID   : byte;
Var
  R : registers;
begin
  r.AH := $F0;
  r.AL := $05;
  intr($21,r);
  GetPrimaryConnectionID := r.AL;
end;

Function AttachToFileServer(ConnectionID : byte)       : byte;
{ ᮥ  䠩-ࢥ}
Var
  R : registers;
begin
  r.AH := $F1;
  r.AL := $00;
  r.DL := ConnectionID;
  intr($21,r);
  AttachToFileServer := r.AL;
end;

Function DetachFromFileServer(ConnectionID : byte)     : byte;
{ ᮥ  䠩-ࢥ}
Var
  R : registers;
begin
  r.AH := $F1;
  r.AL := $01;
  r.DL := ConnectionID;
  intr($21,r);
  DetachFromFileServer := r.AL;
end;

Function LogoutFromFileServer(ConnectionID : byte)     : byte;
{ ॣ஢  䠩-ࢥ}
Var
  R : registers;
begin
  r.AH := $F1;
  r.AL := $02;
  r.DL := ConnectionID;
  intr($21,r);
  LogoutFromFileServer := r.AL;
end;

Procedure GetDriveDirectoryHandle(Var S, O : word);
{   ⠡ ⥫ ᪮}

Var r : registers;

begin
  r.AH := $EF;
  r.AL := 00;
  intr($21,r);
  S := r.ES;
  O := r.SI;
end;

Procedure GetDriveFlag(Var S, O : word);
{   ⠡ 䫠 ᪮}
Var r : registers;

begin
  r.AH := $EF;
  r.AL := 01;
  intr($21,r);
  S := r.ES;
  O := r.SI;
end;

Procedure GetDriveServerTableAddr(Var S, O : word);
{   ⠡ 䨪஢ ᮥ }
Var r : registers;

begin
  r.AH := $EF;
  r.AL := 02;
  intr($21,r);
  S := r.ES;
  O := r.SI;
end;

Procedure GetConnectionTableAddr(Var S,O : word);
{   ⠡ 䨪樮 ஢ ᮥ }
Var r : registers;

begin
  r.AH := $EF;
  r.AL := 03;
  intr($21,r);
  S := r.ES;
  O := r.SI;
end;

Procedure GetServerNameTableAddr(Var S, O : word);
{   ⠡  ஢ }
Var r : registers;

begin
  r.AH := $EF;
  r.AL := 04;
  intr($21,r);
  S := r.ES;
  O := r.SI;
end;

Function GetConnectionNumber      : byte;
{  ᢮  ᮥ  ।⠥ 䠩-ࢥ஬}
var r : registers;

begin
  r.AH := $DC;
  r.AL := 0;
  intr($21,r);
  GetConnectionNumber := r.AL;
end;



End.

