{
                 Independent HelpSoft Laboratory present
            ͻ
                 ˿˿˿ͻ ˿˿ͻ   
                 δ˿              
                                   
                                                              
                 NetWare 3.11 API Library for Turbo Pascal    
                                  by                          
                        S.Perevoznik and V.Kononov            
                                 1994                         
            ͼ
}

Unit NetFile;
{   ࠡ  䠩  쭮 }

Interface

Uses NetConv;
{   ᯮ⥫  }

{ ࠢ 짮⥫  ⠫ ।  ⮬,   }
{   ᫥騥 祭 ⮢,  ࠢ }

Const
  TA_NONE       =  $00;  {   ࠢ                    }
  TA_READ       =  $01;  { 0 - ⥭ 䠩                }
  TA_WRITE      =  $02;  { 1 -  䠩                }
  TA_OPEN       =  $04;  { 2 -  䠩              }
  TA_CREATE     =  $08;  { 3 - ᮧ 䠩              }
  TA_DELETE     =  $10;  { 4 - 㤠 䠩              }
  TA_OWNERSHIP  =  $20;  { 5 - ࠡ  ⠫       }
  TA_SEARCH     =  $40;  { 6 -  䠩                 }
  TA_MODIFY     =  $80;  { 7 - 䨪 ਡ⮢ 䠩 }
  TA_ALL        =  $FF;  {   ࠢ                  }

{ ७ ਡ 䠩 ⠭ ᫥騬 ࠧ: }
{  㪠 ਡ "ࠧ塞" ᯮ 訩   }
{ 筮  ਡ⮢ 䠩.  㪠 ⠫ ਡ-}
{ ⮢ ᯮ ᫥騥   ७ ਡ⮢:  }

{   ਡ   }{ ⠭  ᪠ }

{ 0 - read only    }          { $1  }
{ 1 - hidden       }          { $2  }
{ 2 - system       }          { $4  }
{ 3 - execute only }          { $8  }
{ 4 - directory    }          { $10 }
{ 5 - needs arhived}          { $20 }
{ 6 -              }          { $40 }
{ 7 - shareable    }          { $80 }

Const

 FA_NORMAL           = $00;
 FA_READ_ONLY        = $01;
 FA_HIDDEN           = $02;
 FA_SYSTEM           = $04;
 FA_EXECUTE_ONLY     = $08;
 FA_DIRECTORY        = $10;
 FA_NEEDS_ARCHIVED   = $20;
 FA_SHAREABLE        = $80;

{ ७ ਡ }

{ 4 - transactional}          { $10 }
{ 5 - indexed      }          { $20 }
{ 6 - read audit   }          { $40 }
{ 7 - write audit  }          { $80 }

Const

 FA_TRANSACTIONAL    = $10;
 FA_INDEXED          = $20;
 FA_READ_AUDIT       = $40;
 FA_WRITE_AUDIT      = $80;

Function CreateDirectory( DirectoryHandle    : byte;
                          DirectoryPath      : string;
                          MaximumRightsMask  : byte) : byte;
{   ४  ⥢ ᪥}

Function DeleteDirectory( DirectoryHandle    : byte;
                          DirectoryPath      : string) : byte;
{   ४  ⥢ ᪥}

Function RenameDirectory( DirectoryHandle  : byte;
                          DirectoryPath    : string;
                          NewDirectoryName : string):byte;
{ २뢠  ४ }

Function SetDirectoryInformation( DirectoryHandle : byte;
                                  DirectoryPath   : string;
                                  NewCreationDateAndTime : longint;
                                  NewOwnerObjectID : LongInt;
                                  NewMaximumRightsMask : byte) : byte;
{ ⠭  ଠ  ४ਨ }

Function GetDirectoryPath(DirectoryHandle     : byte;
                          Var directoryPath   : string) : byte;
{ 頥    㪠⥫ }

Function GetVolumeNumber(VolumeName : string;
                         Var VolumeNumber : integer) : byte;
{ 頥  ⮬  㪠  }

Function GetVolumeName(VolumeNumber : integer;
                       Var VolumeName  : string) : byte;
{ 頥  ⮬  㪠 ஬ }


Function PurgeErasedFiles : byte;
{  䠩 ਣ묨  ⠭ }


Function RestoreErasedFile(DriveHandle : byte;
                           VolumeName  : string;
                           Var ErasedFileName ,
                               RestoredFileName : string) : byte;
{ ⠭ 㤠 䠩 }

Function GetDirectoryHandle(Drive : byte;
                            Var Handle : byte) : byte;
{ 頥 ⨯ 㪢 ᪠  ⢥ ᢮ 祭  ।}
{  ⥫ ⠫  ⥢ ᪮}
{ 1 - ﭭ ன⢮ }
{ 2 - ६ ன⢮  }
{ 128 - 쭮 ன⢮}
{  - ⨯ ।}


Function SaveDirectoryHandle(DirectoryHandle : byte;
                             Var SaveBuffer  : String) : byte;
{ ࠭ ଠ  ४ਨ }

Function RestoreDirectoryHandle(SaveBuffer : string;
                                 Var newDirectoryHandle : byte;
                                 Var EffectiveRigthMask : Byte) : byte;
{ ⠭ ࠭ ଠ }


Function SetFileInformation( driveHandle            : byte;
                             filePath               : string;
                             searchAttributes       : byte;
                             fileAttributes         : byte;
                             extendedFileAttributes : byte;
                             creationDate           : integer;
                             lastAccessDate         : integer;
                             lastUpdateDateAndTime  : LongInt;
                             lastArchiveDateAndTime : LongInt;
                             fileOwnerID            : LongInt) : byte;
{  ଠ  䠩 }

Function GetExtendedFileAttributes(FilePath : string;
                                   Var Attr : byte) : byte;
{  ७ ਡ 䠩}


Function SetExtendedFileAttributes(FilePath : string;
                                   attr : byte) : byte;
{ ⠭ ७ ਡ 䠩 }


Function AllocPermanentDirectoryHandle(DirectoryHandle:Byte;
                                         DirectoryPath  :string;
                                         DriveLetter    :char;
                                         Var NewDirectoryHandle,
                                         EffectiveRigthMask : byte):byte;
{  ﭭ ⥫ ⠫ (⮡ࠦ) }

Function AllocTemporaryDirectoryHandle(DirectoryHandle:Byte;
                                         DirectoryPath  :string;
                                         DriveLetter    :char;
                                         Var NewDirectoryHandle,
                                         EffectiveRigthMask : byte):byte;
{  ६ ⥫ ⠫ (⮡ࠦ) }

Procedure DeallocateDirectoryHandle(DirectoryHandle : byte);
{  ⥫ ⠫ }


Implementation

Uses Dos;

Function CreateDirectory( DirectoryHandle    : byte;
                          DirectoryPath      : string;
                          MaximumRightsMask  : byte) : byte;

 var
   r : registers;
   SendPacket  : array[0..261] of byte;
   ReplyPacket : array[0..2] of byte;
   WordPtr     : ^word;
begin
    SendPacket[2] := 10;
    SendPacket[3] := directoryHandle;
    SendPacket[4] := maximumRightsMask;
    SendPacket[5] := Length(DirectoryPath);
    Move(DirectoryPath[1],SendPacket[6],Length(DirectoryPath));
    WordPtr  := addr(SendPacket);
    WordPtr^ := Length(DirectoryPath)+4;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 0;
    r.BX := r.DS;
    r.AH := $0E2;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    CreateDirectory := r.AL;
end;

Function DeleteDirectory( DirectoryHandle    : byte;
                          DirectoryPath      : string) : byte;
{   ४  ⥢ ᪥}
 var
   r : registers;
   SendPacket  : array[0..261] of byte;
   ReplyPacket : array[0..2] of byte;
   WordPtr     : ^word;
begin
    SendPacket[2] := 11;
    SendPacket[3] := directoryHandle;
    SendPacket[4] := 0;
    SendPacket[5] := Length(DirectoryPath);
    Move(DirectoryPath[1],SendPacket[6],Length(DirectoryPath));
    WordPtr  := addr(SendPacket);
    WordPtr^ := Length(DirectoryPath)+4;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 0;
    r.BX := r.DS;
    r.AH := $0E2;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    DeleteDirectory := r.AL;
end;

Function RenameDirectory( DirectoryHandle  : byte;
                          DirectoryPath    : string;
                          NewDirectoryName : string):byte;
{ २뢠  ४ }

 var
   r : registers;
   SendPacket  : array[0..275] of byte;
   ReplyPacket : array[0..2] of byte;
   WordPtr     : ^word;
begin
    SendPacket[2] := 15;
    SendPacket[3] := directoryHandle;
    SendPacket[4] := Length(DirectoryPath);
    Move(DirectoryPath[1],SendPacket[5],Length(DirectoryPath));
    SendPacket[Length(DirectoryPath)+5] := Length(NewDirectoryName);
    

move(NewDirectoryName[1],SendPacket[6+Length(DirectoryPath)],Length(NewDirectory

Name));
    WordPtr  := addr(SendPacket);
    WordPtr^ := Length(DirectoryPath)+4 + Length(NewDirectoryName);
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 0;
    r.BX := r.DS;
    r.AH := $0E2;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    REnameDirectory := r.AL;
end;

Function SetDirectoryInformation( DirectoryHandle : byte;
                                  DirectoryPath   : string;
                                  NewCreationDateAndTime : longint;
                                  NewOwnerObjectID : LongInt;
                                  NewMaximumRightsMask : byte) : byte;
{ ⠭  ଠ  ४ਨ }
 var
   r : registers;
   SendPacket  : array[0..270] of byte;
   ReplyPacket : array[0..2] of byte;
   WordPtr     : ^word;
begin
  SendPacket[2] := 25;
  SendPacket[3] := DirectoryHandle;
  move(NewCreationDateAndTime,SendPacket[4],4);
  NewOwnerObjectID := GetLong(addr(NewOwnerObjectID));
  move(NewOwnerObjectID,SendPacket[8],4);
  SendPacket[12] := newMaximumRightsMask;
  SendPacket[13] := Length(DirectoryPath);
  move(DirectoryPath[1],SendPacket[14],Length(DirectoryPath));
    WordPtr  := addr(SendPacket);
    WordPtr^ := Length(DirectoryPath)+12;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 0;
    r.BX := r.DS;
    r.AH := $0E2;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    SetDirectoryInformation := r.AL;
end;

Function GetDirectoryPath(DirectoryHandle     : byte;
                          Var directoryPath   : string) : byte;
{ 頥    㪠⥫ }
 var
   r : registers;
   SendPacket  : array[0..4] of byte;
   ReplyPacket : array[0..258] of byte;
   WordPtr     : ^word;
begin
  SendPacket[2] := 1;
  SendPacket[3] := DirectoryHandle;
    WordPtr  := addr(SendPacket);
    WordPtr^ := 2;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 256;
    r.BX := r.DS;
    r.AH := $0E2;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    GetDirectoryPath := r.AL;
    if r.AL = 0 then
      begin
        move(ReplyPacket[3],DirectoryPath[1],ReplyPacket[2]);
        move(ReplyPacket[2],DirectoryPath[0],1);
      end;
end;

Function GetVolumeNumber(VolumeName : string;
                         Var VolumeNumber : integer) : byte;
{ 頥  ⮬  㪠  }
 var
   r : registers;
   SendPacket  : array[0..19] of byte;
   ReplyPacket : array[0..3] of byte;
   WordPtr     : ^word;
begin
  SendPacket[2] := 5;
  SendPacket[3] := Length(VolumeName);
  move(VolumeName[1],SendPacket[4],Length(VolumeName));
    WordPtr  := addr(SendPacket);
    WordPtr^ := Length(VolumeName)+2;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 1;
    r.BX := r.DS;
    r.AH := $0E2;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    GetVolumeNumber := r.AL;
    if r.AL = 0 then
      VolumeNumber := ReplyPacket[2];
 end;


Function GetVolumeName(VolumeNumber : integer;
                       Var VolumeName  : string) : byte;
{ 頥  ⮬  㪠 ஬ }

 var
   r : registers;
   SendPacket  : array[0..4] of byte;
   ReplyPacket : array[0..18] of byte;
   WordPtr     : ^word;

begin
   SendPacket[2] := 6;
   SendPacket[3] := VolumeNumber;
    WordPtr  := addr(SendPacket);
    WordPtr^ := 2;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 18;
    r.BX := r.DS;
    r.AH := $0E2;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    GetVolumeName := r.AL;
    if r.AL = 0 then
      begin
        move(ReplyPacket[3],VolumeName[1],ReplyPacket[2]);
        move(ReplyPacket[2],VolumeName[0],1);
      end;
end;

Function PurgeErasedFiles : byte;
{  䠩 ਣ묨  ⠭ }
 var
   r : registers;
   SendPacket  : array[0..2] of byte;
   ReplyPacket : array[0..1] of byte;
   WordPtr     : ^word;
begin
  SendPacket[2] := $10;
    WordPtr  := addr(SendPacket);
    WordPtr^ := 1;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 0;
    r.BX := r.DS;
    r.AH := $0E2;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    PurgeErasedFiles := r.AL;
 end;

Function RestoreErasedFile(DriveHandle : byte;
                           VolumeName  : string;
                           Var ErasedFileName ,
                               RestoredFileName : string) : byte;
{ ⠭ 㤠 䠩 }
 var
   r : registers;
   SendPacket  : array[0..21] of byte;
   ReplyPacket : array[0..32] of byte;
   WordPtr     : ^word;
begin
  SendPacket[2] := $11;
  SendPacket[3] := DriveHandle;
  SendPacket[4] := Length(VolumeName);
  move(VolumeName[1],SendPacket[5],Length(VolumeName));
    WordPtr  := addr(SendPacket);
    WordPtr^ := Length(VolumeName)+3;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 30;
    r.BX := r.DS;
    r.AH := 226;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    RestoreErasedFile := r.AL;
    if r.AL = 0 then
      begin
        move(ReplyPacket[2],ErasedFileName[1],15);
        ErasedFileName[0] := chr(15);
        move(ReplyPacket[17],RestoredFileName[1],15);
        RestoredFileName[0] := chr(15);
      end;
 end;

Function GetDirectoryHandle(Drive : byte;
                            Var Handle : byte) : byte;
{ 頥 ⨯ 㪢 ᪠  ⢥ ᢮ 祭  ।}
{  ⥫ ⠫  ⥢ ᪮}
{ 1 - ﭭ ன⢮ }
{ 2 - ६ ன⢮  }
{ 128 - 쭮 ன⢮}
{  - ⨯ ।}

var r : registers;
begin
  r.AH := $E9;
  r.AL := 0;
  r.DH := 0;
  r.DL := Drive;
  intr($21,r);
  Handle := r.AL;
  GetDirectoryHandle := r.AH;
end;

Function SaveDirectoryHandle(DirectoryHandle : byte;
                             Var SaveBuffer  : String) : byte;
{ ࠭ ଠ  ४ਨ }

 var
   r : registers;
   SendPacket  : array[0..4] of byte;
   ReplyPacket : array[0..16] of byte;
   WordPtr     : ^word;
begin
  SendPacket[2] := 23;
  SendPacket[3] := DirectoryHandle;
    WordPtr  := addr(SendPacket);
    WordPtr^ := 2;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 14;
    r.BX := r.DS;
    r.AH := 226;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    SaveDirectoryHandle := r.AL;
    if r.AL = 0 then
      begin
        move(ReplyPacket[2],SaveBuffer,14);
      end;
 end;

Function RestoreDirectoryHandle(SaveBuffer : string;
                                 Var newDirectoryHandle : byte;
                                 Var EffectiveRigthMask : Byte) : byte;
{ ⠭ ࠭ ଠ }

 var
   r : registers;
   SendPacket  : array[0..19] of byte;
   ReplyPacket : array[0..4] of byte;
   WordPtr     : ^word;
begin
  SendPacket[2] := 24;
  SendPacket[3] := Length(SaveBuffer);
  move(SaveBuffer[1],SendPacket[4],Length(SaveBuffer));
    WordPtr  := addr(SendPacket);
    WordPtr^ := 17;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 2;
    r.BX := r.DS;
    r.AH := 226;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    RestoreDirectoryHandle := r.AL;
    if r.AL = 0 then
      begin
        NewDirectoryHandle := ReplyPacket[2];
        EffectiveRigthMask := ReplyPacket[3];
      end;
 end;

Function SetFileInformation( driveHandle            : byte;
                             filePath               : string;
                             searchAttributes       : byte;
                             fileAttributes         : byte;
                             extendedFileAttributes : byte;
                             creationDate           : integer;
                             lastAccessDate         : integer;
                             lastUpdateDateAndTime  : LongInt;
                             lastArchiveDateAndTime : LongInt;
                             fileOwnerID            : LongInt) : byte;
{  ଠ  䠩 }

 var
   r : registers;
   SendPacket  : array[0..339] of byte;
   ReplyPacket : array[0..2] of byte;
   WordPtr     : ^word;
   i           : integer;

begin
  SendPacket[2] := 16;
  SendPacket[3] := FileAttributes;
  SendPacket[4] := ExtendedFileAttributes;
  SendPacket[5] := 0;
  SendPacket[6] := 0;
  SendPacket[7] := 0;
  SendPacket[8] := 0;
  move(CreationDate,SendPacket[9],2);
  move(LastAccessDate,SendPacket[11],2);
  move(LastUpdateDateAndTime,SendPacket[13],4);
  FileOwnerID := GetLong(addr(FileOwnerID));
  move(FileOwnerID,SendPacket[17],4);
  move(lastArchiveDateAndTime,SendPacket[21],4);
  for i :=  25 to 80 do
    SendPacket[i] := 0;
  SendPacket[81] := DriveHandle;
  SendPacket[82] := searchAttributes;
  SendPacket[83] := Length(FilePath);
  move(FilePath[1],SendPacket[84],Length(FilePath));
    WordPtr  := addr(SendPacket);
    WordPtr^ := Length(FilePath)+ 82;
    WordPtr  := addr(ReplyPacket);
    WordPtr^ := 0;
    r.BX := r.DS;
    r.AH := 227;
    r.DS := SEG(SendPacket);
    r.SI := OFS(SendPacket);
    r.ES := SEG(ReplyPacket);
    r.DI := OFS(ReplyPacket);
    intr($21,r);
    r.DS := r.BX;
    SetFileInformation:= r.AL;
 end;

Function GetExtendedFileAttributes(FilePath : string;
                                   Var Attr : byte) : byte;
{  ७ ਡ 䠩}

var r : registers;
begin
  FilePath[Length(FilePath)+1] := chr(0);
  r.BX := r.DS;
  r.AH := $B6;
  r.AL := 0;
  r.DS := SEG(FilePath[1]);
  r.DX := OFS(FilePath[1]);
  intr($21,r);
  r.DS := r.BX;
  Attr := r.CL;
  if (r.Flags and FCARRY ) = 0 then
  GetExtendedFileAttributes := 0 else
  GetExtendedFileAttributes := r.AL;
end;


Function SetExtendedFileAttributes(FilePath : string;
                                   attr : byte) : byte;
{ ⠭ ७ ਡ 䠩 }

var r : registers;
begin
  FilePath[Length(FilePath)+1] := chr(0);
  r.BX := r.DS;
  r.AH := $B6;
  r.AL := $01;
  r.CL := Attr;
  r.DS := SEG(FilePath[1]);
  r.DX := OFS(FilePath[1]);
  intr($21,r);
  r.DS := r.BX;
  if (r.Flags and FCARRY ) = 0 then
  SetExtendedFileAttributes := 0 else
  SetExtendedFileAttributes := r.AL;
end;

Function AllocPermanentDirectoryHandle(DirectoryHandle:Byte;
                                         DirectoryPath  :string;
                                         DriveLetter    :char;
                                         Var NewDirectoryHandle,
                                         EffectiveRigthMask : byte):byte;
{  ﭭ ⥫ ⠫ (⮡ࠦ) }

Var
  r : registers;
  SendPacket  : array[0..261] of byte;
  ReplyPacket : array[0..004] of byte;
  WordPtr     : ^Word;
begin
  SendPacket[2] := $12;
  SendPacket[3] := DirectoryHandle;
  SendPacket[4] := Ord(DriveLetter);
  move(DirectoryPath,SendPacket[5],Length(DirectoryPath)+1);
  WordPtr  := addr(SendPacket);
  WordPtr^ := Length(DirectoryPath)+4;
  WordPtr  := addr(ReplyPacket);
  WordPtr^ := 2;
  r.BX := r.DS;
  r.AH := $E2;
  r.DS := SEG(SendPacket);
  r.SI := OFS(SendPacket);
  r.ES := SEG(ReplyPacket);
  r.DI := OFS(ReplyPacket);
  intr($21,r);
  r.DS := r.BX;
  AllocPermanentDirectoryHandle := r.AL;
  if r.AL = 0 then
    begin
      NewDirectoryHandle := ReplyPacket[2];
      EffectiveRigthMask := ReplyPacket[3];
    end;
end;



Function AllocTemporaryDirectoryHandle(DirectoryHandle:Byte;
                                         DirectoryPath  :string;
                                         DriveLetter    :char;
                                         Var NewDirectoryHandle,
                                         EffectiveRigthMask : byte):byte;
{  ६ ⥫ ⠫ (⮡ࠦ) }
Var
  r : registers;
  SendPacket  : array[0..261] of byte;
  ReplyPacket : array[0..004] of byte;
  WordPtr     : ^Word;
begin
  SendPacket[2] := $13;
  SendPacket[3] := DirectoryHandle;
  SendPacket[4] := Ord(DriveLetter);
  move(DirectoryPath,SendPacket[5],Length(DirectoryPath)+1);
  WordPtr  := addr(SendPacket);
  WordPtr^ := Length(DirectoryPath)+4;
  WordPtr  := addr(ReplyPacket);
  WordPtr^ := 2;
  r.BX := r.DS;
  r.AH := $E2;
  r.DS := SEG(SendPacket);
  r.SI := OFS(SendPacket);
  r.ES := SEG(ReplyPacket);
  r.DI := OFS(ReplyPacket);
  intr($21,r);
  r.DS := r.BX;
  AllocTemporaryDirectoryHandle := r.AL;
  if r.AL = 0 then
    begin
      NewDirectoryHandle := ReplyPacket[2];
      EffectiveRigthMask := ReplyPacket[3];
    end;
end;

Procedure DeallocateDirectoryHandle(DirectoryHandle : byte);
{  ⥫ ⠫ }
Var
  r : registers;
  SendPacket  : array[0..4] of byte;
  ReplyPacket : array[0..2] of byte;
  WordPtr     : ^Word;
begin
  SendPacket[2] := $14;
  SendPacket[3] := DirectoryHandle;
  WordPtr  := addr(SendPacket);
  WordPtr^ := 2;
  WordPtr  := addr(ReplyPacket);
  WordPtr^ := 0;
  r.BX := r.DS;
  r.AH := $E2;
  r.DS := SEG(SendPacket);
  r.SI := OFS(SendPacket);
  r.ES := SEG(ReplyPacket);
  r.DI := OFS(ReplyPacket);
  intr($21,r);
  r.DS := r.BX;
end;


End.

